Subject: Re: IMQ again WAS(Re: iptables breakage WAS(Re: dummy as IMQ replacement

From: Andy Furniss <[email-masked]>
Date: Mon, 28 Mar 2005 14:39:03 +0100

Andy Furniss wrote:
> jamal wrote:
> 
>>> I'll have to re-run a test I did recently which was lots of tc filter 
>>> matches at 8000pps - on egress IMQ was almost as good as directly on 
>>> eth0. On ingress it was more than 10X worse.
>>>
>> How many filters? I wont suspect any difference between ingress and 
>> egress.
> 
> 
> You are right - the test was to blame.
> 
> I was using my old PC as sender, it's frozen in time at 2.4.20 which for 
> some reason has a txqueuelen on eth0 of 0. It doesn't show using netperf 
> when just testing LAN speed - but makes alot of difference for the test 
> I did - ifconfig eth0 txqueuelen 1000 fixed it.

Hmm - I just tried to recreate another test I did - which was using IMQ 
to shape for a single duplex link. I was going to redo it with dummy, 
but don't seem to be able to put an egress filter on eth0 - eg. Your 
example from the first post in this thread -

What you can do with dummy currently with actions
--------------------------------------------------

Lets say you are policing packets from alias 192.168.200.200/32
you dont want those to exceed 100kbps going out.

tc filter add dev eth0 parent 1: protocol ip prio 10 u32 \
match ip src 192.168.200.200/32 flowid 1:2 \
action police rate 100kbit burst 90k drop

Gives me -

RTNETLINK answers: Invalid argument
We have an error talking to the kernel

Andy.